#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <gtkmm/messagedialog.h>
#include <gtkmm/main.h>
#include "../config.h"
#include "AboutDialog.h"

AboutDialog::AboutDialog(std::string *GladeFilename)
{
	try
	{
		refXml = Gnome::Glade::Xml::create(*GladeFilename, "AboutDialog");
	}
	catch (const Gnome::Glade::XmlError& ex)
	{
		Gtk::MessageDialog *message = new Gtk::MessageDialog("Error reading data file.  Program cannot continue.",
			false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CANCEL,true);
		message->run();
		Gtk::Main::quit();
	}

	refXml->get_widget("AboutDialog",GtkDialog);

	refXml->get_widget("NameLabel",NameLabel);
	refXml->get_widget("LogoImage",LogoImage);

	/* Set the Logo image */
	try {
		LogoImage->set(std::string(DATADIR)+"/pixmaps/vifiricon.png");
	}
	catch (const Glib::FileError& ex) { /* Ignore errors */}

	NameLabel->set_text(std::string(PACKAGE)+" "+std::string(VERSION));
}

AboutDialog::~AboutDialog() {
	delete GtkDialog;
}

int AboutDialog::Run() {
	return GtkDialog->run();
}
