#ifndef APPROACHSEARCHDIALOG_H_
#define APPROACHSEARCHDIALOG_H_

#include <gtkmm/dialog.h>
#include <gtkmm/entry.h>
#include <gtkmm/button.h>
#include <gtkmm/treeview.h>
#include <gtkmm/liststore.h>
#include <gtkmm/box.h>
#include <libglademm.h>
#include "ApproachPlate.h"
#include "DataStore.h"
#include "Config.h"
#include "OnScreenKeypad.h"

class ApproachSearchDialogModelColumns : public Gtk::TreeModelColumnRecord
{
public:
	ApproachSearchDialogModelColumns();

	Gtk::TreeModelColumn<std::string> PlateName;
	Gtk::TreeModelColumn<std::string> AirportIdent;
	Gtk::TreeModelColumn<std::string> AirportName;
	Gtk::TreeModelColumn<std::string> ImgName;
};

class ApproachSearchDialog
{
public:
	ApproachSearchDialog(std::string *GladeFilename, DataStore *Data, Config *Cfg);
	virtual ~ApproachSearchDialog();

	int Run();
private:
	Glib::RefPtr<Gnome::Glade::Xml> refXml;
	Gtk::Dialog *GtkDialog;
	Gtk::Entry *AirportEntry;
	Gtk::TreeView *ApproachesTreeView;
	Gtk::Button *ViewButton;
	Gtk::Button *FrontMatterButton;
	Gtk::Button *CloseButton;
	Gtk::VBox *OnScreenKeypadParent;
	OnScreenKeypad *Keypad;

	ApproachSearchDialogModelColumns Columns;
	Glib::RefPtr<Gtk::ListStore> ListStore;

	void on_AirportEntry_changed();
	void on_ViewButton_clicked();
	void on_FrontMatterButton_clicked();
	void on_CloseButton_clicked();

	Config *Cfg;
	DataStore *Data;

	/* Something to store our matching items in */
	class MatchingItem
	{
	public:
		MatchingItem(Airport *AirP, ApproachPlate *Plate);
		std::string GetAirportIdent();
		std::string GetAirportName();
		std::string GetPlateName();
		std::string GetImgName();
		bool Matchi(std::string str);
	private:
		Airport *AirP;
		ApproachPlate *Plate;
	};
	std::vector<MatchingItem> MatchingItems;
};

#endif /*APPROACHSEARCHDIALOG_H_*/
