#ifndef CHARTCHOOSERDIALOG_H_
#define CHARTCHOOSERDIALOG_H_

#include <string>
#include <gtkmm/dialog.h>
#include <gtkmm/drawingarea.h>
#include <gtkmm/radiobutton.h>
#include <gtkmm/combobox.h>
#include <gtkmm/liststore.h>
#include <gtkmm/label.h>
#include <libglademm.h>
#include "Config.h"
#include "DataStore.h"
#include "ChartChooserDrawingArea.h"
#include "Route.h"

class ChartChooserDialog
{
public:
	ChartChooserDialog(std::string *GladeFilename, Config *Cfg, DataStore *Data, Route *RouteData);
	virtual ~ChartChooserDialog();

	int Run();
	std::vector<GeoChart*>::iterator GetSelectedChart();

private:

	class FlywayComboModelColumns : public Gtk::TreeModel::ColumnRecord {
	public:

		FlywayComboModelColumns() { add(Name); add(Charti); }

		Gtk::TreeModelColumn<std::string> Name;
		Gtk::TreeModelColumn<std::vector<GeoChart*>::iterator> Charti;
	};

	void on_Sectionals_clicked();
	void on_TACs_clicked();
	void on_Flyways_clicked();
	bool on_button_release_event(GdkEventButton * event);
	void on_FlywayComboBox_changed();
	void SetSelectedLabel();

	Glib::RefPtr<Gnome::Glade::Xml> refXml;
	Gtk::Dialog *GtkDialog;
	ChartChooserDrawingArea *HawaiiDrawingArea;
	ChartChooserDrawingArea *AlaskaDrawingArea;
	ChartChooserDrawingArea *ContiguousDrawingArea;
	Gtk::RadioButton *SectionalsRadioButton;
	Gtk::RadioButton *TACsRadioButton;
	Gtk::RadioButton *FlywaysRadioButton;
	Gtk::ComboBox *FlywayComboBox;
	Gtk::Label *SelectedLabel;

	FlywayComboModelColumns FlywayComboColumns;
	Glib::RefPtr<Gtk::ListStore> FlywayComborefTreeModel;

	std::vector<GeoChart*>::iterator SelectedCharti; 
	Config *Cfg;
	DataStore *Data;
};

#endif /*CHARTCHOOSERDIALOG_H_*/
