#ifndef FLASHLIGHTDIALOG_H_
#define FLASHLIGHTDIALOG_H_

#include <string>
#include <gtkmm/dialog.h>
#include <gtkmm/button.h>
#include <gtkmm/radiobutton.h>
#include <gtkmm/scale.h>
#include <gtkmm/drawingarea.h>
#include <gtkmm/label.h>
#include <libglademm.h>

class FlashlightDialog
{
public:
	FlashlightDialog(std::string *GladeFilename);
	virtual ~FlashlightDialog();
	int Run();

private:
	void on_RedRadioButton_clicked();
	void on_WhiteRadioButton_clicked();
	void on_BrightnessHScale_value_changed();
	void on_CloseButton_clicked();
	bool on_BrightnessLabel_mnemonic_activate(bool group_cycling);
	bool on_DrawingArea_expose_event(GdkEventExpose* ev);

	Glib::RefPtr<Gnome::Glade::Xml> refXml;
	Gtk::Dialog *GtkDialog;
	Gtk::RadioButton *RedRadioButton;
	Gtk::RadioButton *WhiteRadioButton;
	Gtk::HScale *BrightnessHScale;
	Gtk::Button *CloseButton;
	Gtk::DrawingArea *DrawingArea;
	Gtk::Label *BrightnessLabel;

	std::string *GladeFilename;
};

#endif /*FLASHLIGHTDIALOG_H_*/
