#ifndef GEOCHART_H_
#define GEOCHART_H_

#include <string>

class GeoChart
{
public:
	enum Type_enum {
		TYPE_SECTIONAL,
		TYPE_TAC,
		TYPE_FLYWAY
	};

	GeoChart();

	void SetFileName(std::string FileName);
	std::string GetFileName();
	void SetName(std::string Name);
	std::string GetName();
	void SetBounding(double North, double East, double South, double West);
	double GetNorthBounding();
	double GetEastBounding();
	double GetSouthBounding();
	double GetWestBounding();
	void SetGeoReferenced(bool GeoReferenced);
	bool GetGeoReferenced();
	void SetType(Type_enum);
	Type_enum GetType();
	bool MakeBinary(struct GeoChart_Binary_struct *BinaryData);
	void SetFromBinary(struct GeoChart_Binary_struct *BinaryData);

private:
	std::string FileName;
	std::string Name;
	double EastBounding,WestBounding,NorthBounding,SouthBounding;
	bool GeoReferenced;
	enum Type_enum Type;
};

/* Increment the version when the structure changes */
#define GEOCHART_BINARY_STRUCT_VER 1
struct GeoChart_Binary_struct {
	char FileName[50];
	char Name[50];
	int32_t NorthBoundingx1000000,EastBoundingx1000000,SouthBoundingx1000000,WestBoundingx1000000;
	uint8_t GeoReferenced;
	uint8_t Type;
} __attribute__ ((packed));


#endif /*GEOCHART_H_*/
