#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <gtkmm/messagedialog.h>
#include <gtkmm/main.h>
#include "GotoDialog.h"

GotoDialog::GotoDialog(std::string *GladeFilename)
{
	try
	{
		std::string gladefile;

		refXml = Gnome::Glade::Xml::create(*GladeFilename, "GotoDialog");
	}
	catch (const Gnome::Glade::XmlError& ex)
	{
		Gtk::MessageDialog *message = new Gtk::MessageDialog("Error reading data file.  Program cannot continue.",
			false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CANCEL,true);
		message->run();
		Gtk::Main::quit();
	}

	refXml->get_widget("GotoDialog",GtkDialog);
	refXml->get_widget("Lattitude",Lattitude);
	refXml->get_widget("Longitude",Longitude);
}

GotoDialog::~GotoDialog() {
	delete GtkDialog;
}

int GotoDialog::Run(double *Lon, double *Lat) {
	int result;
	double NewLon,NewLat;

	result=GtkDialog->run();
	if (result) {
		if (sscanf(Longitude->get_text().c_str(), "%lf", &NewLon)!=1)
			return 0;
		if (sscanf(Lattitude->get_text().c_str(), "%lf", &NewLat)!=1)
			return 0;
		*Lon=NewLon;
		*Lat=NewLat;
	}

	return result;
}
