#ifndef IMPORTDIALOG_H_
#define IMPORTDIALOG_H_

#include <gtkmm/dialog.h>
#include <gtkmm/button.h>
#include <libglademm.h>
#include <string>
#include "DataStore.h"
#include "Config.h"
#include "Shapefile.h"

class ImportDialog
{
public:
	ImportDialog(Config *Cfg, std::string *GladeFilename, DataStore *Data, Shapefile *ShapefileData);
	virtual ~ImportDialog();

	void Run();
private:
	Glib::RefPtr<Gnome::Glade::Xml> refXml,ProgRefXml;
	Gtk::Dialog *GtkDialog;
	Gtk::Button *FlightDBDVDButton;
	Gtk::Button *SectionalsDVDButton;
	Gtk::Button *ApproachesDVDButton;
	Gtk::Button *ShapefileButton;

	Config *Cfg;
	std::string *GladeFilename;
	DataStore *Data;
	Shapefile *ShapefileData;

	void on_FlightDBDVDButton_clicked();
	void on_SectionalsDVDButton_clicked();
	void on_ApproachesDVDButton_clicked();
	void on_ShapefileButton_clicked();
};

#endif /*IMPORTDIALOG_H_*/
