#ifndef IMPORTNATIONALFLIGHTDATABASE_H_
#define IMPORTNATIONALFLIGHTDATABASE_H_

#include <iostream>
#include <fstream>
#include <sys/time.h>
#include <gtkmm/window.h>
#include <gtkmm/progressbar.h>
#include <gtkmm/button.h>
#include "Config.h"
#include "NFD.h"
#include "DataStore.h"

class ImportNationalFlightDatabase
{
public:
	ImportNationalFlightDatabase(Config *Cfg, std::string *GladeFilename, DataStore *Data);
	~ImportNationalFlightDatabase();

	int Run();
	bool ReadLine();
	void on_CancelButton_clicked();
	void ScheduleMainLoop();
	bool ConfirmData();

private:
	static const double ReadingProgressFrac=0.5;
	static const double ParseAirportsProgressFrac=0.1;
	static const double ParseRunwaysProgressFrac=0.1;
	static const double ParseVORsProgressFrac=0.1;
	static const double ParseNDBsProgressFrac=0.1;
	static const double ParseWaypointsProgressFrac=0.1;

	Glib::RefPtr<Gnome::Glade::Xml> refXml;
	Config *Cfg;
	std::string *GladeFilename;
	Gtk::Window *ProgressWindow;
	Gtk::ProgressBar *ProgressBar,*SubProgressBar;
	Gtk::Button *CancelButton;
	int BytesRead,BytesAvail;
	std::ifstream IFStream;
	struct timeval LastProgressBarUpdate;
	bool CancelFlag;
	NFD NFDData;
	DataStore *Data;
	Volume *VolData;
	double ProgressDone;
};

#endif /*IMPORTNATIONALFLIGHTDATABASE_H_*/
