#ifndef IMPORTSECTIONALSDVD_H_
#define IMPORTSECTIONALSDVD_H_

#include <string>
#include <gtkmm/window.h>
#include <gtkmm/progressbar.h>
#include <gtkmm/button.h>
#include "Config.h"
#include "DataStore.h"
#include "OverwriteFileDialog.h"

class ImportSectionalsDVD
{
public:
	ImportSectionalsDVD(Config *Cfg, std::string *GladeFilename, DataStore *Data);
	~ImportSectionalsDVD();

	int Run();
	void on_CancelButton_clicked();

	void ImportSectionals(std::string SrcDir, std::string DstDir);
	void ImportTACs(std::string SrcDir, std::string DstDir);
	void ImportFlyways(std::string SrcDir, std::string DstDir);

private:
	static const double SectionalsProgressFrac=0.6;
	static const double TACsProgressFrac=0.2;
	static const double FlywaysProgressFrac=0.2;

	Config *Cfg;
	std::string *GladeFilename;
	DataStore *Data;
	Volume *VolData;

	Glib::RefPtr<Gnome::Glade::Xml> refXml;
	Gtk::Window *ProgressWindow;
	Gtk::ProgressBar *ProgressBar,*SubProgressBar;
	Gtk::Button *CancelButton;
	bool CancelFlag;
	double ProgressDone;
	OverwriteFileDialog *OFDialog;
};

#endif /*IMPORTSECTIONALSDVD_H_*/
