#ifndef IMPORTSECTIONALSDVDVOLUMECHOOSERDIALOG_H_
#define IMPORTSECTIONALSDVDVOLUMECHOOSERDIALOG_H_

#include <time.h>
#include <gtkmm/dialog.h>
#include <gtkmm/combobox.h>
#include <gtkmm/label.h>
#include <gtkmm/liststore.h>
#include <libglademm.h>
#include <string>

class ImportSectionalsDVDVolumeChooserDialog
{
public:
	ImportSectionalsDVDVolumeChooserDialog(std::string *GladeFilename, std::string DataPath);
	~ImportSectionalsDVDVolumeChooserDialog();

	int Run();
	void GetData(std::string *Volume, time_t *EffectiveFrom, time_t *EffectiveTo);

private:
	class VolumeComboModelColumns : public Gtk::TreeModel::ColumnRecord {
	public:

		VolumeComboModelColumns() { add(Volume); add(EffectiveFrom); }

		Gtk::TreeModelColumn<std::string> Volume;
		Gtk::TreeModelColumn<time_t> EffectiveFrom;
	};

	void on_VolumeComboBox_changed();
	void PopulateVolumeComboBox();
	bool ParseMetaDate(std::string Line, time_t *Date);

	std::string DataPath;
	Glib::RefPtr<Gnome::Glade::Xml> refXml;
	Gtk::Dialog *GtkDialog;
	Gtk::ComboBox *VolumeComboBox;
	Gtk::Label *EffectiveFromLabel;
	Gtk::Label *EffectiveToLabel;

	std::string Volume;
	time_t EffectiveFrom;
	static const unsigned int EffectiveDuration=28*24*60*60;

	VolumeComboModelColumns VolumeComboColumns;
	Glib::RefPtr<Gtk::ListStore> VolumeComborefTreeModel;
};

#endif /*IMPORTSECTIONALSDVDVOLUMECHOOSERDIALOG_H_*/
