#ifndef METARS_H_
#define METARS_H_

#include <list>
#include <curl/curl.h>
#include "METAR.h"
#include "Config.h"

class METARs
{
public:
	METARs(Config *Cfg);
	virtual ~METARs();

	std::string CycleURL(short Offset);
	bool Download();
	bool DownloadCycleFileURL(std::string URL);
	std::list<METAR> *GetStations();
	size_t GetStationCount();
	void CleanUp();
	bool Save();
	bool Load();
	void Clear();

private:
	std::list<METAR> Stations;
	static size_t CurlWriteHandler(void *ptr, size_t size, size_t nmemb, METARs *stream);
	void CurlCleanup(CURL *Curl);
	char *CurlData;
	size_t CurlDataSize;
	Config *Cfg;
};

#endif /*METARS_H_*/
