#ifndef OVERWRITEFILEDIALOG_H_
#define OVERWRITEFILEDIALOG_H_

#include <string>
#include <gtkmm/dialog.h>
#include <gtkmm/label.h>
#include <gtkmm/button.h>
#include <libglademm.h>

/* This class is designed to be instantiated once per group of similar file
 * operations.  The Run() method should be executed repeatedly for each conflicting
 * file.  Delete when the group of file operations are done
 */

class OverwriteFileDialog
{
public:
	enum Do_enum {
		DO_ASK,
		DO_KEEPALL,
		DO_OVERWRITEALL
	};

	/* The response given as a result of Run() */
	enum Response_enum {
		RESPONSE_CANCEL,
		RESPONSE_KEEP,
		RESPONSE_OVERWRITE,
	};

	/* The internal responses to button clicks */
	enum Response_Internal_enum {
		RESPONSE_INTERNAL_CANCEL,
		RESPONSE_INTERNAL_KEEP,
		RESPONSE_INTERNAL_OVERWRITE,
		RESPONSE_INTERNAL_KEEPALL,
		RESPONSE_INTERNAL_OVERWRITEALL
	};

	OverwriteFileDialog(std::string *GladeFilename);
	virtual ~OverwriteFileDialog();

	enum Response_enum Run(std::string Path);
	void Reset();
	void SetPath(std::string Path);

private:
	Glib::RefPtr<Gnome::Glade::Xml> refXml;
	Gtk::Dialog *GtkDialog;
	Gtk::Label *PathLabel;

	enum Do_enum Do;
};

#endif /*OVERWRITEFILEDIALOG_H_*/
