#define __STDC_LIMIT_MACROS
#include <stdint.h>
#include "RoutePoint.h"

/* A RoutePoint is a Waypoint that's part of a route.  It includes such
 * additional things as a target altitude
 */

RoutePoint::RoutePoint()
{
	Altitude=0;
}

RoutePoint::RoutePoint(Waypoint *WP) {
	this->ID=WP->GetID();
	this->Name=WP->GetName();
	this->Lon=WP->GetLon();
	this->Lat=WP->GetLat();
	this->LocType=WP->GetLocType();
	Altitude=0;
}

void RoutePoint::SetAltitude(unsigned int Altitude)
{
	this->Altitude=Altitude;
}

void RoutePoint::SetLonLatAlt(double Lon, double Lat,unsigned int Alt)
{
	SetLonLat(Lon,Lat);
	SetAltitude(Alt);
}

unsigned int RoutePoint::GetAltitude()
{
	return Altitude;
}

bool RoutePoint::MakeBinary(struct RoutePoint_Binary_struct *BinaryData) {
	/* Sanity checking */
	if (
		Altitude<INT32_MIN || Altitude>INT32_MAX
		) {
		return false;
	}

	BinaryData->Altitude=Altitude;
	if (!Waypoint::MakeBinary(&(BinaryData->Waypoint))) {
		return false;
	}

	return true;
}

void RoutePoint::SetFromBinary(struct RoutePoint_Binary_struct *BinaryData) {
	Altitude=BinaryData->Altitude;
	Waypoint::SetFromBinary(&(BinaryData->Waypoint));
}
