#ifndef WAYPOINT_H_
#define WAYPOINT_H_

#include <string>
#include <math.h>

class Waypoint
{
public:
	enum LocType_enum {
		LOC_UNKNOWN,
		LOC_AIRPORT,
		LOC_NAVAID,
		LOC_ENROUTEWAYPOINT
	};

	Waypoint();

	double GetLon();
	double GetLat();
	std::string GetID();
	void SetLonLat(double Lon, double Lat);
	bool Matchi(std::string Str);
	enum LocType_enum GetLocType();
	std::string GetLocTypeStr(enum LocType_enum LocType);
	std::string GetLocTypeStr();
	std::string GetName();
	bool MakeBinary(struct Waypoint_Binary_struct *BinaryData);
	void SetFromBinary(struct Waypoint_Binary_struct *BinaryData);

protected:
	std::string ID;
	std::string Name;
	double Lon,Lat;
	enum LocType_enum LocType;
};

/* Increment the version when the structure changes */
#define WAYPOINT_BINARY_STRUCT_VER 1
struct Waypoint_Binary_struct {
	char ID[5];
	char Name[50];
	int32_t Lonx1000000,Latx1000000;
	uint8_t LocType;
} __attribute__ ((packed));

#endif /*WAYPOINT_H_*/
